doinst() {
## Check for fsck.vfat, if none, create one
fsck_vfat_check()
	{	
	if [ ! -r /sbin/fsck.vfat ]; then
		ln -s /sbin/dosfsck /sbin/fsck.vfat
	fi
	}
## Create Sudo Rule
make_sudoers_temp()
	{
	cp /etc/sudoers /etc/sudoers.old
	cp /etc/sudoers /etc/sudoers.copy
	chmod 777 /etc/sudoers.copy
	}
add_tc_sudo_rule()
	{
	cat >> /etc/sudoers.copy <<EOF

##TrueCrypt Rules
%users ALL = (root) /usr/bin/truecrypt --core-service
EOF
	}
save_sudoers_mods()
	{
	cp /etc/sudoers.copy /etc/sudoers
	chmod 0440 /etc/sudoers
	}
create_sudoers()
	{
	cp /etc/sudoers.new /etc/sudoers
	}

##Add dm-crypt mappings removal code to /etc/rc.d/rc.6
tc_rm_map()
	{
	if ! grep -q "truecrypt -l" /etc/rc.d/rc.6; then
	perl -pi -le 'print "" if $. == 176' /etc/rc.d/rc.6
	perl -pi -le 'print "  # Try to remove any dm-crypt mappings (for TrueCrypt)" if $. == 177' /etc/rc.d/rc.6
	perl -pi -le 'print "  if [ -x /usr/bin/truecrypt ]; then" if $. == 178' /etc/rc.d/rc.6
	perl -pi -le 'print "  echo \"Removing TrueCrypt mappings\"" if $. == 179' /etc/rc.d/rc.6
	perl -pi -le 'print "    ! /usr/bin/truecrypt -l > /dev/null 2>&1  || /usr/bin/truecrypt -d" if $. == 180' /etc/rc.d/rc.6
	perl -pi -le 'print "  fi" if $. == 181' /etc/rc.d/rc.6
	fi
	}

	
fsck_vfat_check
if [ ! -r /etc/sudoers ]; then
	create_sudoers
	make_sudoers_temp
	add_tc_sudo_rule
	save_sudoers_mods
	rm /etc/sudoers.copy
else
	make_sudoers_temp
	if ! grep -q "%users ALL = (root) /usr/bin/truecrypt --core-service" /etc/sudoers.copy; then
		add_tc_sudo_rule
		save_sudoers_mods
		rm /etc/sudoers.copy
	else
		rm /etc/sudoers.copy
	fi	
fi
tc_rm_map

exit 0
}
doinst
